; acl2r

(include-book "nonstd/nsa/overspill" :dir :system)

; From ~/acl2/acl2/books/nonstd/nsa/overspill-test.lisp:

(encapsulate
 ((r (k y) t)) ; classical predicate (necessary for overspill)
 (local (defun r (k y) (declare (ignore k y)) t))
 (defthm r-prop
   (and (r 0 z)
        (implies (and (natp j)
                      (standardp j))
                 (r j z)))))

(overspill r x)

:pcb! :x

(defthm r-holds-on-i-large
  (let ((n (r-witness x)))
    (and (natp n)
         (i-large n)
         (implies (and (natp m) (<= m n))
                  (r m x))))
  :hints (("Goal" :use r-overspill))
  :rule-classes nil)
