(defstub p0 (x y z) t)
(defstub q0 (x y z) t)
:trans1 (defun-sk exists-x-p0-and-q0 (y z)
          (exists x
                  (and (p0 x y z)
                       (q0 x y z))))

#||
 (ENCAPSULATE
  NIL (LOGIC)
  (SET-MATCH-FREE-DEFAULT :ALL)
  (SET-INHIBIT-WARNINGS "Theory"
                        "Use" "Free" "Non-rec" "Infected")
  (ENCAPSULATE
    ((EXISTS-X-P0-AND-Q0-WITNESS (Y Z) X))
    (LOCAL (IN-THEORY '(IMPLIES)))
    (LOCAL (DEFCHOOSE EXISTS-X-P0-AND-Q0-WITNESS (X)
                      (Y Z)
                      (AND (P0 X Y Z) (Q0 X Y Z))))
    (DEFUN-NX EXISTS-X-P0-AND-Q0 (Y Z)
              (DECLARE (XARGS :NON-EXECUTABLE T))
              (LET ((X (EXISTS-X-P0-AND-Q0-WITNESS Y Z)))
                   (AND (P0 X Y Z) (Q0 X Y Z))))
    (IN-THEORY (DISABLE (EXISTS-X-P0-AND-Q0)))
    (DEFTHM
         EXISTS-X-P0-AND-Q0-SUFF
         (IMPLIES (AND (P0 X Y Z) (Q0 X Y Z))
                  (EXISTS-X-P0-AND-Q0 Y Z))
         :HINTS (("Goal" :USE (EXISTS-X-P0-AND-Q0-WITNESS EXISTS-X-P0-AND-Q0)
                         :IN-THEORY (THEORY 'MINIMAL-THEORY))))))
||#
