(encapsulate ((spec (x) t :guard (integerp x)))
             (local (defun spec (x) (+ x 3)))
             (defthm integerp-spec
               (implies (integerp x)
                        (integerp (spec x)))))

(defun f (x y)
  (declare (type integer x y))
  (spec (+ x y)))

(defun impl (x)
  (declare (type integer x))
  (* 10 x))

(defattach spec impl)
